/* eslint-disable no-magic-numbers */

import { Item } from './items.js';
import { chooseItems } from './solver.js';

import knapsackImage from './images/knapsack.svg';
import styles from './solution.module.css';

function formatSolution(solution) {
  return solution.map((item) => `(weight: ${item.weight}, value: ${item.value})`).join(', ');
}

const ITEMS = [
  new Item(3, 10),
  new Item(4, 14),
];
const WEIGHT_LIMIT = 10;

export function Solution() {
  const solution = chooseItems(ITEMS, WEIGHT_LIMIT);
  return (
    <div>
      <figure className={styles.diagram} >
        <img src={knapsackImage} alt="A weighted directed graph corresponding to the knapsack problem." />
      </figure>
      <label>
        Chosen Knapsack Items: <output>{formatSolution(solution)}</output>
      </label>
    </div>
  );
}
