/* eslint-disable no-magic-numbers */

import { wrap } from './solver.js';

import wrappingImage from './images/wrapping.svg';
import styles from './solution.module.css';

function formatSolution(solution) {
  return solution.map((count) => `after ${count} word${count !== 1 ? 's' : ''}`).join(', ');
}

const WORD_LENGTHS = [1, 1, 1, 1, 4, 4];
const LINE_LENGTH = 7;

export function Solution() {
  const solution = wrap(WORD_LENGTHS, LINE_LENGTH);
  return (
    <div>
      <figure className={styles.diagram} >
        <img src={wrappingImage} alt="A weighted directed graph corresponding to the line-wrapping problem." />
      </figure>
      <label>
        Line Break Locations: <output>{formatSolution(solution)}</output>
      </label>
    </div>
  );
}
