function penalty(characterCount, lineLength) {
  return (lineLength - characterCount) ** 2;
}

class Backpointer {
  constructor(previousIndex, totalPenalty) {
    this.previousIndex = previousIndex;
    this.totalPenalty = totalPenalty;
  }
}

function chooseBackpointer(wordLengths, lineLength, backpointers) {
  const index = backpointers.length;
  let best = new Backpointer(undefined, Infinity);
  // TODO: stub
  console.assert(
    best.previousIndex !== undefined,
    `One of the word lengths ${wordLengths} is too long to fit in a line of length ${lineLength}.`,
  );
  return best;
}

export function wrap(wordLengths, lineLength) {
  const backpointers = [new Backpointer(undefined, 0)];
  while (backpointers.length <= wordLengths.length) {
    backpointers.push(chooseBackpointer(wordLengths, lineLength, backpointers));
  }
  const results = [];
  for (let index = wordLengths.length; index > 0; index = backpointers[index].previousIndex) {
    results.push(index);
  }
  return results.reverse();
}
